

FeatMonitor_noOnigiri = {}
FeatMonitor_noOnigiri.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_noOnigiri"
	this.params = paramas
	
	this.featId = "noOnigiri"
	this.featName = "省エネの鬼"
	this.description = "おにぎりを一度も使わずにCHALLENGE MODEのエリア1つ分をクリア。"
	
	this.currentState = { goodWillLeft = 0, areaB }
	this.prevState = { goodWillLeft = 0, areaB }
	this.lastUseAreaA = 0
	this.lastUseAreaB = 4
	
	this.isAchieved = false

	--=========================================================
	-- フラグリセット
	--=========================================================
	this.reset = function (self)
	
		self.currentState = { goodWillLeft = 0, areaB }
		self.prevState = { goodWillLeft = 0, areaB }
		self.lastUseAreaA = 0
		self.lastUseAreaB = 4
		
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		self.prevState.goodWillLeft = self.currentState.goodWillLeft
		self.prevState.areaB = self.currentState.areaB

		self.currentState.goodWillLeft = goodWillLeft
		self.currentState.areaB = areaB
		
		-- おにぎりを使った
		if ( self.currentState.goodWillLeft < self.prevState.goodWillLeft ) then
			
			--print ("おにぎりを使った")
			
			self.lastUseAreaA = areaA
			self.lastUseAreaB = areaB
		end
		
		-- エリア進んだ
		if ( self.currentState.areaB ~= self.prevState.areaB  ) then

			--print ("エリア進んだ")
			
			local areaNum = areaA * 4 + areaB
			local areaNum_lastUse = self.lastUseAreaA * 4 + self.lastUseAreaB
			
			if ( areaNum - areaNum_lastUse > 4  ) then
				self.isAchieved = true
				setFeatAchievedMessage ( self )
			end
			
		end
		
	end
	

	
	return this
end
 

