--=========================================================
--
-- 善意
--
--=========================================================

Goodwill = {}
Goodwill.new = function ( params )
	
	local this = {}
	this.className = "Goodwill"
	this.params = paramas
	
	this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
--	this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.spriteQuad_banish = {}
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 3 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 4 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.x = 0
	this.y = 0
	this.speed = 10
	
	this.isEnd = false
	this.isBanishing = false
	this.banishAnimeCount = 0
	this.banishAnimeWait = 0
	this.banishAnimeWaitMax = 2

	this.hitSize = 20
--	this.hitSize = 15
	this.hitOffsetX = 0
	this.hitOffsetY = 2
	
	this.duration = 0
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		self.duration = self.duration + 1
		
		if ( not self.isBanishing ) then
		
			self.y = self.y - self.speed
			
			if ( self.y < SPRITE_HEIGHT * -1 ) then
				consecution = 0
				self.isEnd = true
				--isOnigiriMissed = true -- 実績の判定用
			end

			-- 未知との当たり判定
			for i = 1, #unknowns, 1 do
			
				if ( not unknowns[i].isLeaving ) then
					local distToUnknown = utils.getDistance ( 
						self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
						unknowns[i].x + unknowns[i].hitOffsetX, unknowns[i].y + unknowns[i].hitOffsetY ) 
					
					if ( distToUnknown < ( unknowns[i].hitSize + self.hitSize ) ) then
						
						print ("未知に おにぎり 当たった")

						consecution = consecution + 1
						if ( consecution > 1 ) then
							addEffectMessage ( consecution .. " deliveries!", self.x, self.y )
						end
						
						if ( consecution >= 10 ) then
							
							if ( consecution%2 == 0 ) then
								addItem ( "limitUp" )
							end
						end
						
						unknowns[i]:recieveGoodWill(self)
						
						self.isEnd = true
						break
					end
				end
			end
			
			-- 岩との当たり判定
			if ( not self.isEnd ) then -- 先に未知に当たっていたら、岩との判定は行わない
				for i = 1, #rocks, 1 do
				
					local distToRock = utils.getDistance ( 
						self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
						rocks[i].x + rocks[i].hitOffsetX, rocks[i].y + rocks[i].hitOffsetY ) 
					
					if ( distToRock < ( rocks[i].hitSize + self.hitSize ) ) then
						
--						self.isEnd = true
--						print ("当たった")

						playSound ( sounds["banish"] )
						
						self.isBanishing = true
						self.banishAnimeCount = 1
						self.banishAnimeWait = self.banishAnimeWaitMax
						
						isOnigiriMissed = true
						
						consecution = 0

						break
					end
				end
			end
			
			
		-- 消滅中
		else
			--[[
				this.banishAnimeCount = 0
				this.banishAnimeWait = 0
				this.banishAnimeWaitMax = 2
			]]--
			
			if ( self.banishAnimeWait <= 0 ) then
				self.banishAnimeCount = self.banishAnimeCount + 1
				self.banishAnimeWait = self.banishAnimeWaitMax
				
				if ( self.banishAnimeCount > #self.spriteQuad_banish ) then
					self.isEnd = true
				end
			else
				self.banishAnimeWait = self.banishAnimeWait - 1
			end
			
			
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)

		if ( self.isEnd ) then
			return
		end
	
		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )
		
		local drawX = self.x - SPRITE_WIDTH/2
		local drawY = self.y - SPRITE_HEIGHT/2
		
		if ( self.isBanishing ) then
			love.graphics.draw ( spriteSheet, self.spriteQuad_banish[self.banishAnimeCount], drawX, drawY )
		else
			love.graphics.draw ( spriteSheet, self.spriteQuad, drawX, drawY )
		end

		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end

GoodWill = Goodwill

