
utf8 = require("utf8")
require ( "circulateRandom" )
require ( "sub" )
require ( "storyDemo" )
require ( "star" )
require ( "rock" )
require ( "goodwill" )
require ( "reaction" )
require ( "item" )
require ( "unknown" )
require ( "unknown_big" )
require ( "playerMachine" )
require ( "effectMessage" )
require ( "featWindow" )
require ( "narrationBox" )
require ( "tutorial" )
require ( "left" )

utils = require("utils")

IMAGE_DIR = "images"
AUDIO_DIR = "audio"

stars = {}
goodWills = {}
rocks = {}
unknowns = {}
reactions = {}
items = {}
effectMessages = {}

colors = {White = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 }, Unknown = { r = 1.0, g = 1.0, b = 0.0, a = 1.0 }, A = { r = 0.0, g = 1.0, b = 0.0, a = 1.0 }, B = { r = 1.0, g = 0.0, b = 0.0, a = 1.0 } }

planetm = {
	image = love.graphics.newImage ( IMAGE_DIR .. "/" .. "planetm.png" ),
	x = nil,
	y = nil,
}

mode = nil
isStageEnd = false
stage = 1
areaA = 1
areaB = 1
areaA_last = 10
stage_last = 5
goodWillLeftInit = 30
goodWillLeft = goodWillLeftInit
energyInit = 50
energy = energyInit
energyMaxInit = 100
energyMax = energyMaxInit
energyPrev = nil
frameCount = 0

leftInit = 3
leftInit_challenge = 2
--left = leftInit
left_reset(leftInit)

--leftTest = Left.new()

leftToGoalInit_first = 60*20
leftToGoalInit = 60*60
leftToGoal = leftToGoalInit
mileage = 0
consecution = 0
numOfDeliveries = 0

stageCallingCount = 0
stageCallingCountInit = 100

stageClearCount = 0
stageClearCountInit = 100

featWindow = nil
featMonitors = {}
featAchievedMessages = {}

narrationBox = nil

reactionBconsecution = 0 -- 赤が連続する場合に緑に調整する理不尽感リリーフ
reactionBconsecutionLimit = 2

newAreaReachMessage = nil


nonRepeatButton_up = false
nonRepeatButton_down = false
nonRepeatButton_z    = false
gamePad = {}

phase = ""
storyDemo_onAir = nil

waitToStart = true

--=========================================================
-- ロード
--=========================================================
function love.load() 
	
	-- FPS固定法：https://love2d.org/wiki/love.timer.sleep
	min_dt = 1/60
	next_time = love.timer.getTime()
	
	love.audio.setVolume(0.1)
	
	
	-- 乱数まわりの準備
	math.randomseed(os.time())
	crand = CirculateRandom.new ( {min = 1, max = 10, times = 1}  ) -- テスト用
	crand_forAB = CirculateRandom.new ( {min = 1, max = 2, times = 5}  )
	crand_forLR = CirculateRandom.new ( {min = 1, max = 2, times = 5}  )
	crand_forResAngle = CirculateRandom.new ( {min = 45, max = 135, times = 3}  )
	
	WIDTH, HEIGHT, FLAGS = love.window.getMode()

	spriteSheet = love.graphics.newImage ( IMAGE_DIR .. "/" .. "spriteSheet.png" )

	SPRITE_WIDTH = 32
	SPRITE_HEIGHT = 32

	spriteQuad_pcMachine = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	spriteQuad_goodwill  = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 1 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )


	canvas_title = love.graphics.newCanvas ( WIDTH, HEIGHT )
	canvas_field = love.graphics.newCanvas ( 600, HEIGHT )
	canvas_score = love.graphics.newCanvas ( WIDTH - canvas_field:getWidth(), HEIGHT )

	titleLogo = love.graphics.newImage ( IMAGE_DIR .. "/" .."title.png" )
	titleX = canvas_title:getWidth()/2
	titleY_goal = math.floor(canvas_title:getHeight()/2.5)
	titleY_init = canvas_title:getHeight() + titleLogo:getHeight()/2
	titleY = titleY_init
	titleDecideCountdown = 0
	titleCursorIndex = 1

--	titleMenu = { "STORY MODE", "ENDLESS MODE"}
	titleMenu = { "STORY MODE", "CHALLENGE MODE", "ACHIEVEMENTS", "TUTORIAL" }


	fonts = {}
	fonts.default         = love.graphics.newFont("PixelMplus10-Regular.ttf", 18)
	fonts.score           = love.graphics.newFont("PixelMplus10-Regular.ttf", 20)
	fonts.areaMessage     = love.graphics.newFont("PixelMplus10-Regular.ttf", 40)
	fonts.featDescription = love.graphics.newFont("PixelMplus10-Regular.ttf", 15)
	fonts.featState       = love.graphics.newFont("PixelMplus10-Regular.ttf", 20)
	fonts.goodWillLeft    = love.graphics.newFont("PixelMplus10-Regular.ttf", 30)

	sounds = {
		bgm         = love.audio.newSource ( AUDIO_DIR .."/".."BGM099-100910-yumenonakadetobiokiru-wav.wav", "stream" ),
		stage1      = love.audio.newSource ( AUDIO_DIR .."/".."BGM244-221031-nijuuhadounoana-wav.wav", "stream" ),
		stage2      = love.audio.newSource ( AUDIO_DIR .."/".."BGM218-181031-funikuchozouko-wav.wav", "stream" ),
		stage3      = love.audio.newSource ( AUDIO_DIR .."/".."BGM177-151031-seikoushitajikken-wav.wav", "stream" ),
		stage4      = love.audio.newSource ( AUDIO_DIR .."/".."BGM155-131031-zetsubounosuana-wav-nointro.wav", "stream" ),
		stage5      = love.audio.newSource ( AUDIO_DIR .."/".."BGM244-221031-nijuuhadounoana-wav.wav", "stream" ),
		end_story     = love.audio.newSource ( AUDIO_DIR .."/".."BGM034-070512-nonbirimarutagoya-wav.wav", "stream" ),
		end_challenge = love.audio.newSource ( AUDIO_DIR .."/".."BGM004-061201-tsuchiijiri-mp3.ogg", "stream" ),
		challenge_first = love.audio.newSource ( AUDIO_DIR .."/".."BGM137-121031-zenjinmitou-wav.wav", "stream" ),
		challenge_second = love.audio.newSource ( AUDIO_DIR .."/".."BGM190-161031-mogurihisomikaikuguru-wav.wav", "stream" ),
		challenge_final  = love.audio.newSource ( AUDIO_DIR .."/".."BGM205-171031-gasatsukuokusoko-wav.wav", "stream" ),
		
		
		connection  = love.audio.newSource ( AUDIO_DIR .."/".."オフ＿消灯.wav", "static" ),
		crash       = love.audio.newSource ( AUDIO_DIR .."/".."ヒット＿強打2.wav", "static" ),
		damage      = love.audio.newSource ( AUDIO_DIR .."/".."ヒット＿通常5.wav", "static" ),
		wrack       = love.audio.newSource ( AUDIO_DIR .."/".."ヒット＿通常4.wav", "static" ),
		alert       = love.audio.newSource ( AUDIO_DIR .."/".."エラー2.wav", "static" ),
		emptyGas    = love.audio.newSource ( AUDIO_DIR .."/".."雷系＿小さい雷.wav", "stream" ),
		goodWill    = love.audio.newSource ( AUDIO_DIR .."/".."武器＿鞭を振るう.wav", "static" ),
		banish      = love.audio.newSource ( AUDIO_DIR .."/".."武器＿盾.wav", "static" ),
		empty       = love.audio.newSource ( AUDIO_DIR .."/".."魔物＿つぶす.wav", "static" ),
		reaction    = love.audio.newSource ( AUDIO_DIR .."/".."そのほか＿吸収.wav", "static" ),
		reaction2   = love.audio.newSource ( AUDIO_DIR .."/".."決定＿小決定（SF系）.wav", "static" ),
		reaction3   = love.audio.newSource ( AUDIO_DIR .."/".."回復系＿回復.wav", "static" ),
		gain        = love.audio.newSource ( AUDIO_DIR .."/".."ステータス変化系＿パワーアップ.wav", "static" ),
		lose        = love.audio.newSource ( AUDIO_DIR .."/".."雷系＿電気.wav", "static" ),
		cursorMove  = love.audio.newSource ( AUDIO_DIR .."/".."カーソル（キンとする）2.wav", "static" ),
		decide      = love.audio.newSource ( AUDIO_DIR .."/".."決定＿大決定（SF系）3.wav", "static" ),
		laser       = love.audio.newSource ( AUDIO_DIR .."/".."射撃＿ビーム2.wav", "static" ),
		rockBanish  = love.audio.newSource ( AUDIO_DIR .."/".."決定＿大決定（コミカル系）2.wav", "static" ),
		charPut     = love.audio.newSource ( AUDIO_DIR .."/".."そのほか＿ぴょこっと生える.wav", "static" ),
		--charPut     = love.audio.newSource ( AUDIO_DIR .."/".."決定＿小決定（固い）2.wav", "static" ),
		--charPut     = love.audio.newSource ( AUDIO_DIR .."/".."カーソル（柔らかい）.wav", "static" ),
		
		achieved    = love.audio.newSource ( AUDIO_DIR .."/".."アイテム＿アイテム獲得大（SF）.wav", "static" ),
		clear       = love.audio.newSource ( AUDIO_DIR .."/".."BGM200-171031-konotenitsukame-intro-wav.wav", "stream" ),
		newArea     = love.audio.newSource ( AUDIO_DIR .."/".."決定＿大決定（ファンタジー系）2.wav", "static" ),
		
		opening = love.audio.newSource ( AUDIO_DIR .."/".."BGM209-171031-zaininnnoipponmichi-wav.wav", "stream" ),

		testSound     = love.audio.newSource ( AUDIO_DIR .."/".."BGM200-171031-konotenitsukame-intro-wav.wav", "stream" ),
		testSound2    = love.audio.newSource ( AUDIO_DIR .."/".."決定＿大決定（ファンタジー系）2.wav", "static" ),

	}

	storyDemos = {
		test = "test", --StoryDemo.new ( scripts["test"] ),

		op = "storyDemoOP1", --StoryDemo.new ( scripts["storyDemoOP1"] ),
		stage1 = "storyDemo1", --StoryDemo.new ( scripts["storyDemo1"] ),
		stage2 = "storyDemo2", --StoryDemo.new ( scripts["storyDemo2"] ),
		stage3 = "storyDemo3", --StoryDemo.new ( scripts["storyDemo3"] ),
		stage4 = "storyDemo4", --StoryDemo.new ( scripts["storyDemo4"] ),
		stage5 = "storyDemoED1", -- StoryDemo.new ( scripts["storyDemoED1"] ),
		challenge = "storyDemo_challengeEND" -- StoryDemo.new ( scripts["storyDemo_challengeEND"] ),
	}

	
	featMonitors = {
		FeatMonitor_tutorialComplete.new(),
		FeatMonitor_firstStageClear.new(),
		FeatMonitor_allClear.new(),
		FeatMonitor_allClear_noMiss.new(),

		FeatMonitor_afar1.new(),
		FeatMonitor_afar2.new(),
		FeatMonitor_afar3.new(),
		FeatMonitor_allAreaClear.new(),
		FeatMonitor_allAreaClear_noMiss.new(),

		FeatMonitor_consecution1.new(),
		FeatMonitor_consecution2.new(),
		FeatMonitor_consecution3.new(),

		FeatMonitor_charge1.new(),
		FeatMonitor_charge2.new(),
		FeatMonitor_charge3.new(),
		FeatMonitor_left1.new(),
		FeatMonitor_left2.new(),
		FeatMonitor_noOnigiri.new(),
		FeatMonitor_exploreTheGreatUnknown.new(),
		FeatMonitor_recoverFromNearDeath.new(),
	}
	toLoad()
	featWindow = FeatWindow.new()
	
	narrationBox = NarrationBox.new()


	for i = 1, 100, 1 do
		stars[#stars + 1] = Star.new()
	end
	
	playerMachine = PlayerMachine.new()
	playerMachine:init()
	
	frameCount = 0
	
	
	toTitle()

--	startFirstStage()
--	mode = "story"

end

--=========================================================
-- 終了時処理
--=========================================================
function love.quit()
	
	print("終了イベント")
	
	toSave()
	
	
	return false --trueにすると終了を抑制する
end

--=========================================================
-- キー押下
--=========================================================
function love.keypressed ( key )

	if ( key == "z" ) then nonRepeatButton_z = true end
	if ( key == "up"   ) then nonRepeatButton_up   = true end
	if ( key == "down" ) then nonRepeatButton_down = true end
	
	if ( key == "f9" ) then isFPSShown = not isFPSShown end
	if ( key == "f2" ) then isHitAreaShown = not isHitAreaShown end
	
	if ( key == "return" ) then
		--playerMachine:crash()
		--addItem("onigiriA")
		
		--planetm.y = - planetm.image:getHeight()
		--planetm.x = -100
		--addUnknown_big(1)
		
		-- エンディングだけ確認したいときに
		--isStageEnd = true
		
	end
	
	-- リセット
	if (key == "r") then
		if ( love.keyboard.isDown ("lctrl") or love.keyboard.isDown ("rctrl") ) then
			love.event.quit( "restart" )
		end
	end
	
	-- 垂直同期
	if ( key == "o" ) then 
		if ( love.keyboard.isDown ("lctrl") or love.keyboard.isDown ("rctrl") ) then
		
			local vsync = love.window.getVSync()
			if ( vsync == 1 ) then 
				love.window.setVSync(0)
				
				min_dt = 1/120
			else
				love.window.setVSync(1)
				min_dt = 1/60
			end
		end
	end
	
	if ( key == "space" ) then
		waitToStart = false
	end
end

--=========================================================
-- ゲームパッド押下
--=========================================================
function love.gamepadpressed(joystick, button)
--	print (joystick:getName() ..":"..button)

	if ( button:find( "stick" ) ) then 
--		nonRepeatButton_z = true
	else
		if ( button:find( "up"   ) ) then nonRepeatButton_up   = true ; gamePad["up"] = true
		elseif ( button:find( "down" ) ) then nonRepeatButton_down = true ; gamePad["down"] = true
		elseif ( button:find( "left" ) and not button:find( "shoulder" ) ) then gamePad["left"] = true
		elseif ( button:find( "right" ) and not button:find( "shoulder" )  ) then gamePad["right"] = true
		else 
			nonRepeatButton_z = true
		end
	end
	
end
function love.gamepadreleased(joystick, button)
	--print ("[放]"..joystick:getName() ..":"..button)
	
	if ( button:find( "up"   ) ) then    gamePad["up"] = false
	elseif ( button:find( "down" ) ) then gamePad["down"] = false
	elseif ( button:find( "left" ) ) then gamePad["left"] = false
	elseif ( button:find( "right" ) ) then gamePad["right"] = false
	end
	
end

--=========================================================
-- アナログスティック
--=========================================================
stickPad = nil
function love.gamepadaxis(joystick, axis, value)
	stickPad = joystick
end
function getStickDeg () 
	
	local degree = nil
	local direction = nil
	
	local getBiggerAbs = function ( a, b ) 
		local r = a
		if ( math.abs ( a ) < math.abs ( b ) ) then r = b end
		return r
	end
	
	if ( stickPad ) then
		local thr = 0.5
--		local stickY = stickPad:getGamepadAxis("lefty")
--		local stickX = stickPad:getGamepadAxis("leftx")
		local stickY = getBiggerAbs ( stickPad:getGamepadAxis("lefty"), stickPad:getGamepadAxis("righty") )
		local stickX = getBiggerAbs ( stickPad:getGamepadAxis("leftx"), stickPad:getGamepadAxis("rightx") )
		
		if ( math.abs(stickX) > thr or math.abs(stickY) > thr ) then
			local r = math.atan2 ( stickY, stickX )
			degree = math.deg ( r )
			--print (degree)
		end
	end
	
	if ( degree ) then
		
		local UP    = -90
		local LEFT  = 180
		local RIGHT = 0
		local DOWN  = 90
		
		local range = 30
		
		if ( math.abs(degree - (UP))    < range  ) then direction = "UP" end
		if ( math.abs(degree - (LEFT))  < range  ) then direction = "LEFT" end
		if ( math.abs(degree - (RIGHT)) < range  ) then direction = "RIGHT" end
		if ( math.abs(degree - (DOWN))  < range  ) then direction = "DOWN" end
		
	end
	
	return degree, direction
end
--=========================================================
-- タイトルへ
--=========================================================
function toTitle () 
	phase = "title"
	mode = ""
	titleY = titleY_init
	titleDecideCountdown = 0
	energy = energyInit
	energyMax = energyMaxInit
	stage = 0
	consecution = 0
	reactionBconsecution = 0
end

--=========================================================
-- チュートリアル開始
--=========================================================
function startTutorial ()
	
	phase = "main"
	stage = 0
	mileage = 0
	areaA = 0
	areaB = 0

	consecution = 0
	numOfDeliveries = 0
	leftToGoal = leftToGoalInit
	energyMax = energyMaxInit
	energy = 60
	goodWillLeft = 50
	--left = leftInit
	left_reset(leftInit)
	
	stageCallingCount = stageCallingCountInit
	isStageEnd = false
	
	frameCount = 0
	rocks = {}
	unknowns = {}
	reactions = {}
	goodWills = {}
	items = {}
	
	narrationBox:init()
	playerMachine:init()
	
	stopBGM()

end

--=========================================================
-- ステージ開始（ステージ１）
--=========================================================
function startFirstStage ()

	phase = "stageCall"
	stage = 1
	mileage = 0
	areaA = 1
	areaB = 1
	
	consecution = 0
	numOfDeliveries = 0
	
	leftToGoal = leftToGoalInit_first
--	leftToGoal = leftToGoalInit
	energyMax = energyMaxInit
	energy = energyInit
	goodWillLeft = goodWillLeftInit

--	left = leftInit
--	left_reset(leftInit)

	if (mode == "endless") then
		left_reset(leftInit_challenge)
		
		challengeModeBGM = "challenge_first"
	else
		left_reset(leftInit)
	end
	
	stageCallingCount = stageCallingCountInit
	frameCount = 0
	isStageEnd = false
end

--=========================================================
-- ステージ開始（新）
--=========================================================
function startNewStage ( stageNum )
	
	phase = "stageCall"
	stage = stageNum
	leftToGoal = leftToGoalInit
	energy = energy + 30 --energyInit
	goodWillLeft = goodWillLeftInit
	stageCallingCount = stageCallingCountInit
	isStageEnd = false

	if ( energy > energyMax ) then energy = energyMax end

	playSound ( sounds["gain"] )
	addEffectMessage ( "Energy +30", canvas_field:getWidth()/2, canvas_field:getHeight()/1.5, 0.01 )
	addEffectMessage ( "Onigiri =30", canvas_field:getWidth()/2, canvas_field:getHeight()/1.5 + 40, 0.01 )

	if ( stage == stage_last ) then
		showNewAreaReachMessage ( "LAST STAGE" )
	end
	
end

--=========================================================
-- ステージ再開（現）
--=========================================================
function restartStage ()
	phase = "stageCall"
	stageCallingCount = stageCallingCountInit
	
	energyMax = energyMaxInit
	
	--playerMachine.isCrashing = false
	--playerMachine.x = canvas_field:getWidth()/2
	--playerMachine.y = canvas_field:getHeight() + SPRITE_HEIGHT
end



--=========================================================
-- 更新
--=========================================================
function love.update ( dt ) 
	
	-- FPS固定法：https://love2d.org/wiki/love.timer.sleep
	next_time = next_time + min_dt
	
	
--	if ( waitToStart ) then
--		return
--	end
	
	if ( energyPrev == nil ) then
		energyPrev = energy
	else
		energyPrev = utils.Approach ( energyPrev, energy, 1 )
	end
    
	-- 新エリア到達メッセージ
	if ( newAreaReachMessage ) then
		
		local fontForField = fonts.score
		local w = fontForField:getWidth ( newAreaReachMessage )
		newAreaReachMessageX = newAreaReachMessageX - 7
		
		if ( newAreaReachMessageX < -w ) then
			newAreaReachMessage = nil
		end
	end
		    
	-- エフェクトメッセージ
	local updatedEffectMessageList = {}
	for i = 1, #effectMessages, 1 do
		effectMessages[i]:update()
		
		if ( not effectMessages[i].isEnd ) then
			updatedEffectMessageList[#updatedEffectMessageList + 1] = effectMessages[i]
		end
	end
	effectMessages = updatedEffectMessageList

	-- 実績モニター
	if ( mode ~= "tutorial" ) then -- チュートリアルの中で連続deliverが成立していたりする
		for i = 1, #featMonitors, 1 do
			featMonitors[i]:update()
		end
	end
	
	-- 実績達成メッセージ
	local updatedFeatAchievedMessages = {}
	for i = 1, #featAchievedMessages, 1 do
		featAchievedMessages[i]:update()
		if ( not featAchievedMessages[i].isEnd ) then
			updatedFeatAchievedMessages [ #updatedFeatAchievedMessages + 1 ] = featAchievedMessages[i]
		end
	end
	featAchievedMessages = updatedFeatAchievedMessages
	
	-- 惑星M
	if ( planetm.y ) then
		planetm.y = planetm.y + 1
		if ( planetm.y > HEIGHT ) then
			planetm.y = nil
		end
	end
		
	if ( phase == "main" ) then
		phase_main()
		
	elseif ( phase == "stageCall" ) then
		phase_stageCall()
		
	elseif ( phase == "stageClear" ) then
		phase_stageClear()
		
	elseif ( phase == "gameOver" ) then
		phase_gameOver()

	elseif ( phase == "title" ) then
		phase_title()		

	elseif ( phase == "storyDemo" ) then
		phase_storyDemo()
		
	end

	nonRepeatButton_up = false
	nonRepeatButton_down = false
	nonRepeatButton_z = false	
	
	local anaDeg, anaDir = getStickDeg()
	
	if ( preAnaDir == nil ) then
		if ( anaDir == "UP" ) then nonRepeatButton_up = true end
		if ( anaDir == "DOWN" ) then nonRepeatButton_down = true end
	end
	preAnaDeg, preAnaDir = anaDeg, anaDir



	if ( mode == "tutorial" ) then
		narrationBox:update()
	end
end

--=========================================================
-- 更新＿フェイズ：タイトル
--=========================================================
function phase_title ()
	
	-- 背景の星スクロール
	for i = 1, #stars, 1 do
		stars[i]:update()
	end

	-- 実績ウィンドウ
	if ( featWindow.isActive ) then
		featWindow:update()
		return
	end

	if ( titleDecideCountdown > 0 ) then
		
		titleDecideCountdown = titleDecideCountdown - 1
		if ( titleDecideCountdown == 0 ) then
		
			-- 実績の内部判定フラグをリセット
			resetAchievementsFlags()
			
			if ( titleCursorIndex == 1 ) then
				print("ストーリーモード")
				mode = "story"

--				storyDemo_onAir = storyDemos["stage" .. tostring(stage)]
				storyDemo_onAir = StoryDemo.new ( scripts[storyDemos["op"]] )
				                                   
				storyDemo_onAir:reset()

				phase = "storyDemo"
				frameCount = 0

			elseif ( titleCursorIndex == 2 ) then
				print("エンドレスモード")
				mode = "endless"
				startFirstStage()
				
			elseif ( titleCursorIndex == 4 ) then
				print("チュートリアル")
				mode = "tutorial"
				startTutorial()
				
			end
			
--			startFirstStage()
		end
		
	else
		-- ロゴを下から上にニューンと動かすやつ。上に移動済みなら、タイトル画面本番
		if ( titleY == titleY_goal ) then
			
			if ( nonRepeatButton_up ) then
				if (titleCursorIndex > 1 ) then
					titleCursorIndex = titleCursorIndex - 1
					playSound ( sounds["cursorMove"] )
				end
			end
			if ( nonRepeatButton_down ) then
				if (titleCursorIndex < #titleMenu ) then
					titleCursorIndex = titleCursorIndex + 1
					playSound ( sounds["cursorMove"] )
				end
			end
			
			if ( nonRepeatButton_z ) then
				
				if ( titleCursorIndex == 3 ) then
					
					featWindow:show()
					
				else
					playSound ( sounds["decide"] )
					titleDecideCountdown = 60 --1
				end
				
				
			end
			
		-- ロゴを上にニューン
		else
			titleY = utils.Approach ( titleY, titleY_goal, 3)

			if ( nonRepeatButton_z ) then
				titleY = titleY_goal
			end
		end
	end

end


--=========================================================
-- 更新＿フェイズ：ストーリーデモ
--=========================================================
function phase_storyDemo_dummy ()
	
	-- ボタン押下で次のステージへ
	if ( nonRepeatButton_z ) then
	
		if ( stage == 0 ) then
			startFirstStage()
		else
			startNewStage (stage + 1)
		end
	end

end 
function phase_storyDemo ()

	frameCount = frameCount + 1
	
	if ( storyDemo_onAir ) then
		storyDemo_onAir:update()
		
		-- 早送り
		local anaDeg, anaDirection = getStickDeg()
		if ( love.keyboard.isDown("down") or gamePad["down"] or anaDirection == "DOWN" ) then
			for i = 1, 20, 1 do
				storyDemo_onAir:update()
			end
		end
		
		-- [Z] で強制終了
		if ( nonRepeatButton_z ) then
			storyDemo_onAir.isEnd = true
		end
	end
	
	-- デモ終了していたら
	if ( storyDemo_onAir.isEnd ) then
	
		-- チャレンジモード
		if ( mode == "endless" ) then
			
			-- ボタン押下待っておこうか。
			if ( nonRepeatButton_z ) then
				-- ストーリーデモは最後の１つだけ、という前提。エリアは確認しない
				storyDemo_onAir:destruct()
				storyDemo_onAir = nil
				toTitle()
				nonRepeatButton_z = false -- ニューンが飛ばされないようにする
			end
		
		-- ストーリーモード：最大5面。
		elseif ( mode == "story") then
		
			if ( stage == stage_last ) then
				-- デモを終了して
				storyDemo_onAir:destruct()
				storyDemo_onAir = nil
				
				-- タイトル画面に戻る
				toTitle()
			else
				-- ボタン押下で次のステージへ
				if ( nonRepeatButton_z ) then
					storyDemo_onAir:destruct()
					storyDemo_onAir = nil
					
					if ( stage == 0 ) then
						startFirstStage()
					else
						startNewStage (stage + 1)
					end
				end
			end
		end
	end
		
	
end


--=========================================================
-- フェイズ：ステージコール
--=========================================================
function phase_stageCall ()

	-- ステージコール中
	if ( stageCallingCount > 0 ) then
		
		-- コール時、最初の処理
		if ( stageCallingCount == stageCallingCountInit ) then
			
			playerMachine.isCrashing = false
			playerMachine.x = canvas_field:getWidth()/2
			playerMachine.y = canvas_field:getHeight() + SPRITE_HEIGHT
			
		end
		
		playerMachine.y = playerMachine.y - 2
		if ( playerMachine.y < canvas_field:getHeight() / 1.5 ) then
			playerMachine.y = canvas_field:getHeight() / 1.5
		end

		
		stageCallingCount = stageCallingCount - 1
	
	-- コール終了
	else
		phase = "main"
		--playBGM ( sounds["bgm"] )
		
		if ( mode == "story" ) then
			
			if ( stage >= 1 and stage <= 5 ) then
				
				local soundId = "stage" .. tostring(stage)
				playBGM ( sounds[ soundId ] )
				
			end
			
		elseif ( mode == "endless" ) then
			
			playBGM ( sounds[ challengeModeBGM ] )
			
		end
	end

end

--=========================================================
-- 更新＿フェイズ：ステージクリア
--=========================================================
function phase_stageClear ()
	
	if ( playerMachine.y < -1 * SPRITE_HEIGHT ) then
		
		stageClearCount = stageClearCount -1 
		if ( stageClearCount <= 0 ) then
			
			if ( mode == "story" ) then

				--startNewStage (stage + 1)
				
				frameCount = 0
				phase = "storyDemo"
				
--				storyDemo_onAir = storyDemos["stage"..tostring(stage)]
				storyDemo_onAir = StoryDemo.new ( scripts[ storyDemos["stage"..tostring(stage)] ] )
				if ( storyDemo_onAir ) then
					storyDemo_onAir:reset()
				end
				
			elseif ( mode == "endless" ) then
				
				-- このモードでのストーリーデモはエンディングのみ（判定不要という意味）
				
				phase = "storyDemo"
				storyDemo_onAir = StoryDemo.new ( scripts[ storyDemos["challenge"]] )
				storyDemo_onAir:reset()
				
				
			end
		end
	else
		playerMachine.y = playerMachine.y - 8
	end

end

--=========================================================
-- 更新＿フェイズ：ゲームーバー
--=========================================================
function phase_gameOver ()
	
	if ( nonRepeatButton_z ) then
		toTitle()
	end
end

--=========================================================
-- メインフェイズ
--=========================================================
function phase_main()
	
	frameCount = frameCount + 1

	-- クラッシュ中
	if ( playerMachine.isCrashing ) then
		
		stopBGM()
	
		--if ( playerMachine.isCrashing and leftToGoal > 0 ) then
		
		-- 画面内に出ている岩と未知と返答が消えるのを待ってフェイズを進める
		if ( #rocks == 0 and #unknowns == 0 and #reactions == 0 and #items == 0 ) then
			
			if ( mode == "tutorial" ) then
				
				if ( type(tutorialRestartCountdown) == "number" ) then
					
					tutorialRestartCountdown = tutorialRestartCountdown - 1
					if ( tutorialRestartCountdown <= 0 ) then
						tutorialRestartCountdown = nil
						--left = left - 1
						newMachine = left_get()
						energy = energyInit
						if (newMachine) then energy = energy + newMachine.energyExtra end
						
						playerMachine:init()
					end
					
				else
					tutorialRestartCountdown = 120
				end
				
				-- クラッシュ中も呼んでおく
				tutorial_Field()
				
			else
			
				-- 残機なし
				--if ( left <= 0 ) then
				if ( #left <= 0 ) then
					
					phase = "gameOver"
					
				-- 残機あり
				else
					--left = left - 1
					newMachine = left_get()
					energy = energyInit
					if (newMachine) then energy = energy + newMachine.energyExtra end
					
					
					restartStage() 
				end
			end
			
		end
	
	-- 道中（メインのゲーム部分）
	--elseif ( leftToGoal > 0 ) then
	elseif ( not isStageEnd ) then
		
		if ( mode == "story" ) then
		
			-- 目標地点に近づく
			if ( frameCount%1 == 0) then
				leftToGoal = leftToGoal - 1
				
				-- 目標地点到達で、ステージクリア
				if ( leftToGoal <= 0 ) then isStageEnd = true end
			end
			
			-- 惑星M登場
			if ( stage == stage_last and leftToGoal == 2000 ) then
				planetm.x = 400
				planetm.y = -300
			end
			
		elseif ( mode == "endless" ) then
		
			-- 航行距離を加算
			if ( frameCount%1 == 0) then
				mileage = mileage + 1
			end

			-- 惑星M登場
			if ( areaA == 5 and areaB == 2 and mileage%1000 == 500 ) then
				planetm.x = -50
				planetm.y = -300
				
				challengeModeBGM = "challenge_second"
				playBGM ( sounds [challengeModeBGM] )
			end
			-- エリア進行
			if ( mileage%1000 == 0) then
				
				if ( areaA == areaA_last and areaB == 4 ) then
					
					isStageEnd = true
					
					stopBGM ()
					
				else
					areaB = areaB + 1
					if ( areaB > 4 ) then
						areaB = 1
						areaA = areaA + 1

--						addItem ( "onigiriB" )

						if ( areaA >= 8 ) then
							addItem ( "onigiriD" )
						elseif ( areaA >= 5 ) then
							addItem ( "onigiriC" )
						else
							addItem ( "onigiriB" )
						end
						
						if ( areaA == 9 ) then
							challengeModeBGM = "challenge_final"
							playBGM ( sounds [challengeModeBGM] )
						end
						
					else
						addItem ( "onigiriA" )
					end
					
					local areaText = "AREA " .. string.format ( "%01d", areaA ) .. "-" .. string.format ( "%01d", areaB )

					if ( areaA == areaA_last and areaB == 1 ) then
						areaText = "LAST AREA"
					end
					
					showNewAreaReachMessage ( areaText )
				end
			end
			
		
		elseif ( mode == "tutorial" ) then
			tutorial_Field()
		end
		
		-- 燃料を減らす
		if ( frameCount%30 == 0) then
			energy = energy - 1
		end
		
		if ( mode ~= "tutorial" ) then
		
			local rockFreq, rockNum = getRockData()
			
			-- 岩出現
			--if ( frameCount%100 == 0 ) then
			--	addRock()
			--end
			--if ( frameCount%30 == 0 ) then
			--	addRock(3)
			--end
			if ( frameCount%rockFreq == 0 ) then
				addRock(rockNum)
			end
			
			-- 「未知」出現
			--if ( frameCount%50 == 0 ) then
			--	addUnknown()
			--end
			if ( frameCount%100 == 0 ) then
				addUnknown()
			end
		end
		
	--[[ playerMachine側で管理する
		-- エネルギー切れ
		if ( energy < 0 ) then
			energy = 0
			if ( not playerMachine.isCrashing ) then
				playerMachine:crash()
			end
		end
	]]--
	
	-- ステージ終了判定 isStageEnd
	-- ゴール到達 → クリアフェイズまで	
	else
		
		stopBGM()
		
		-- 画面内に出ている岩と未知と返答が消えるのを待ってフェイズを進める
		if ( #rocks == 0 and #unknowns == 0 and #reactions == 0 and #goodWills == 0 and #items == 0) then
			
			phase = "stageClear"
			stageClearCount = stageClearCountInit
			playSound ( sounds["clear"] )
			
		end

	end
		
	-- 背景の星スクロール
	for i = 1, #stars, 1 do
		stars[i]:update()
	end
	
			
	-- 自機
	playerMachine:update()
	if ( energy < 0 ) then energy = 0 end
	
	-- おにぎり
	isOnigiriMissed = false
	local updatedGoodWillList = {}
	for i = 1, #goodWills, 1 do
		goodWills[i]:update()
		
		if ( not goodWills[i].isEnd ) then
			updatedGoodWillList[#updatedGoodWillList + 1] = goodWills[i]
		end
	end
	goodWills = updatedGoodWillList
	
	-- 岩
	local updatedRockList = {}
	for i = 1, #rocks, 1 do
		rocks[i]:update()
		
		if ( not rocks[i].isEnd ) then
			updatedRockList[#updatedRockList + 1] = rocks[i]
		end
	end
	rocks = updatedRockList

	-- アイテム
	local updatedItemList = {}
	for i = 1, #items, 1 do
		items[i]:update()
		
		if ( not items[i].isEnd ) then
			updatedItemList[#updatedItemList + 1] = items[i]
		end
	end
	items = updatedItemList
		
	-- 未知
	local updatedUnknownList = {}
	for i = 1, #unknowns, 1 do
		unknowns[i]:update()
		
		if ( not unknowns[i].isEnd ) then
			updatedUnknownList[#updatedUnknownList + 1] = unknowns[i]
		end
	end
	unknowns = updatedUnknownList
	
	-- 返答
	local updatedReactionList = {}
	for i = 1, #reactions, 1 do
		reactions[i]:update()
		
		if ( not reactions[i].isEnd ) then
			updatedReactionList[#updatedReactionList + 1] = reactions[i]
		end
	end
	reactions = updatedReactionList
	
end

--=========================================================
-- 描画
--=========================================================
function love.draw() 
	
	local currentCanvas = love.graphics.getCanvas()
	local currentFont   = love.graphics.getFont()


	-- ストーリーデモがあれば優先
	if ( storyDemo_onAir ) then

--		love.graphics.print ( "ストーリーデモ表示予定", 300, 280)

		storyDemo_onAir:draw()
		
		if ( storyDemo_onAir.isEnd ) then
		
			local prompt = "Press [Z] to the Next Stage"
			if ( stage == 0 ) then
				prompt = "Press [Z] to the First Stage"
			end

			if ( mode == "endless" ) then
				prompt = "Press [Z] to the Title Screen"
			end
			
			local font = fonts.score
			love.graphics.setFont ( fonts.score )
			
			if ( frameCount%30 < 15 ) then
				love.graphics.setColor (1,1,1,1)
			else
				love.graphics.setColor (1,1,1,0)
			end
			
			if ( prompt ) then
--				love.graphics.print ( prompt, 20, 7 ) -- 上に表示
				love.graphics.print ( prompt, 20, HEIGHT - math.ceil((font:getHeight()*1.2)) ) -- 下に表示
			end
			
		elseif ( frameCount < 180 ) then
			local font = fonts.score
			love.graphics.setFont ( fonts.score )

			love.graphics.setColor (1,1,1,1)
			
			if ( frameCount%20 < 10 ) then
			--	love.graphics.setColor (1,1,0,1)
			else
			--	love.graphics.setColor (0,0,1,1)
			end
			
			--local guide = "Press [↓] to skip"
			local guide = "[↓] SKIP  [Z] END"
			love.graphics.print ( guide, 20, HEIGHT - math.ceil((font:getHeight()*1.2)) )

		end
		
	-- タイトル画面
	elseif ( phase == "title" ) then
	
		love.graphics.setCanvas ( canvas_title )
		love.graphics.clear(0,0,0,1)

		for i = 1, #stars, 1 do
			stars[i]:draw()
		end		
		
		love.graphics.setColor (1,1,1,1)
		love.graphics.draw ( titleLogo, titleX, titleY, 0, 1.0, 1.0, titleLogo:getWidth()/2, titleLogo:getHeight()/2 )

		local fontForTitle = fonts.score
		love.graphics.setFont ( fontForTitle )

		love.graphics.setColor (1,1,1,1)
		love.graphics.print ( version, titleX + 200, titleY + 200 )
		
		
		if ( titleY == titleY_goal ) then
			
			for i = 1, #titleMenu, 1 do
				love.graphics.setColor (1,1,1,1)
				love.graphics.print ( titleMenu[i], canvas_title:getWidth()/2 - 50, math.floor(canvas_field:getHeight()/1.25) + 30*(i-1) )
				
				if ( titleDecideCountdown > 0 and titleDecideCountdown%10 > 5 ) then
					love.graphics.setColor (1,1,1,0)
				end
				if ( titleCursorIndex == i ) then
					love.graphics.print ( "▲", canvas_title:getWidth()/2 - 60, math.floor(canvas_field:getHeight()/1.25) + 3 + 30*(i-1), math.rad(-270) )
				end				

			end
			
		end
		
		love.graphics.setColor (1,1,1,1)
		love.graphics.setCanvas(currentCanvas)
		love.graphics.draw ( canvas_title, 0, 0 )

	-- それ以外
	else
		
		-- キャンバス・フィールド
		love.graphics.setCanvas ( canvas_field )
		love.graphics.clear(0,0,0,1)
		
		local fontForField = fonts.score
		love.graphics.setFont ( fontForField )
		
		-- 背景の星描画
		for i = 1, #stars, 1 do
			stars[i]:draw()
		end

		-- 木星
		if ( planetm.y ) then
			love.graphics.draw ( planetm.image, planetm.x, planetm.y )
		end		

		-- 未知描画
		for i = 1, #unknowns, 1 do
			unknowns[i]:draw()
		end
			
		-- 自機描画
		playerMachine:draw()

		-- エフェクトメッセージ
		for i = 1, #effectMessages, 1 do
			effectMessages[i]:draw()
		end

		-- アイテム描画
		for i = 1, #items, 1 do
			items[i]:draw()
		end
		
		-- おにぎり描画
		for i = 1, #goodWills, 1 do
			goodWills[i]:draw()
		end
		
		-- 岩
		for i = 1, #rocks, 1 do
			rocks[i]:draw()
		end
		
		-- 反応
		for i = 1, #reactions, 1 do
			reactions[i]:draw()
		end


		-- ステージコール中
		if ( phase == "stageCall" ) then
			
			local stageName = "STAGE "..string.format ( "%01d", stage )
			
			if ( mode == "endless" ) then
				stageName = "AREA " .. string.format ( "%01d", areaA ) .. "-" .. string.format ( "%01d", areaB )
			end

			local w = fontForField:getWidth ( stageName )
			
			if ( stageCallingCount%20 < 10 ) then
				love.graphics.setColor (1,1,1,1)
			else
				love.graphics.setColor (1,1,1,0)
			end
			
			love.graphics.print ( stageName, canvas_field:getWidth()/2 - w/2, canvas_field:getHeight()/2.5 )
			
		end
		
		-- ステージクリア時
		if ( phase == "stageClear" ) then
			
			local text = "STAGE "..string.format ( "%01d", stage ) .. " CLEAR!!"
			if ( mode == "endless" ) then
				text = " FINISHED!!" -- 冒頭の半角スペースは、中心に表示した際の見た目のバランス取り
			end
			
			local w = fontForField:getWidth ( text )
			
			if ( stageCallingCount%6 < 3 ) then
				love.graphics.setColor (1,1,1,1)
			else
				love.graphics.setColor (1,1,1,0)
			end
			
			love.graphics.print ( text, canvas_field:getWidth()/2 - w/2, canvas_field:getHeight()/2.5 )
			
		end
		
		-- ゲームオーバー時
		if ( phase == "gameOver" ) then
			
			local text = "GAME OVER"
			local w = fontForField:getWidth ( text )
			
			love.graphics.print ( text, canvas_field:getWidth()/2 - w/2, canvas_field:getHeight()/2.5 )
			
		end
		
		-- 新エリア到達メッセージ
		if ( newAreaReachMessage ) then
			
			local w = fontForField:getWidth ( newAreaReachMessage )
			
			local colors = {
				{1,0,0}, {0,1,0}, {0,0,1},{ 1,1,0 }, {1,1,1}
			}
			love.graphics.setColor ( colors [ (math.ceil( os.clock()*500 /2))%(#colors) + 1] )
			
			love.graphics.setFont(fonts.areaMessage)
			
			love.graphics.print ( newAreaReachMessage, newAreaReachMessageX, canvas_field:getHeight()/2.5 )
			
		--	newAreaReachMessageX = newAreaReachMessageX - 7
		--	if ( newAreaReachMessageX < -w ) then
		--		newAreaReachMessage = nil
		--	end
		end
		love.graphics.setColor (1,1,1,1)

		-- エネルギー残量を画面上に出す試み
		--drawEnergyGauge ( 10, 10 ) --400, 10 )
		--drawEnergyGauge ( 10, canvas_field:getHeight() - 40 ) --400, 10 )
			
		-- キャンバス・スコア関連
		love.graphics.setCanvas ( canvas_score )
		love.graphics.clear(0.1,0.2,0.6, 1)
		love.graphics.setFont ( fonts.score )


		if ( mode == "story" ) then

			-- ステージ番号
			love.graphics.print ( "STAGE："..string.format ( "%01d", stage ), 55, 100 )

			-- ステージクリアまでの航行距離
			love.graphics.print ( "目標宙域まで："..string.format ( "%04d", leftToGoal ), 10, 150 )
		
		elseif ( mode == "endless" ) then
		
			love.graphics.print ( "AREA："..string.format ( "%01d", areaA ).."-"..string.format ( "%01d", areaB ), 55, 100 )
			love.graphics.print ( "航行距離  ："..string.format ( "%04d", mileage ), 10, 150 )
			
		elseif ( mode == "tutorial" ) then
			love.graphics.print ( "TUTORIAL", 55, 100 )
		end


		-- エネルギー残量
		drawEnergyGauge ( 5, 200 )
		--love.graphics.print ( "ENERGY："..string.format ( "%03d", energy ).."/"..energyMax, 30, 200 )
		
		-- おにぎりの残個数
		drawGoodWillLeft ( 15, 280 )
		--love.graphics.print ( "おにぎり残り："..string.format ( "%03d", goodWillLeft ), 20, 250 )

		-- ロゴ
		love.graphics.draw ( titleLogo, 20, 470, 0, 0.25 )
		
		
		-- 残機数
		--love.graphics.print ( "残機："..string.format ( "%03d", left ), 50, 300 )
		-- 残機
	--[[
		for i = 0, left-1, 1 do
			local drawX = 10 + (i%5) * SPRITE_WIDTH + 2
			local drawY = 360 + (math.floor(i/5)) * SPRITE_HEIGHT + 1
			love.graphics.draw ( spriteSheet, spriteQuad_pcMachine, drawX, drawY )
		end		
	]]--
		for i = 0, #left-1, 1 do
			local drawX = 10 + (i%5) * SPRITE_WIDTH + 2
			local drawY = 360 + (math.floor(i/5)) * SPRITE_HEIGHT + 1
			
			left[i+1]:draw( drawX, drawY )
		end
		
				

		-- 各キャンバスを描画
		love.graphics.setCanvas(currentCanvas)
		love.graphics.draw ( canvas_field, 0, 0 )
		love.graphics.draw ( canvas_score, canvas_field:getWidth(), 0 )
		
		love.graphics.setFont ( currentFont )
	end
	
	
	drawFeatAchievedMessage()
	
	featWindow:draw()
	
	if ( mode == "tutorial" ) then
		narrationBox:draw()
		
		for id, outerText in pairs(tutorial_outerTexts) do
			
			local r,g,b,a = love.graphics.getColor()
			love.graphics.setColor ( outerText.color )
			printWithOutline ( outerText.text, tonumber(outerText.x), tonumber(outerText.y), fonts[outerText.font], 1 )
			love.graphics.setColor (r,b,g,a)
			
		end
		
	end
		
	love.graphics.setColor (1,1,1,1)
	
	if ( isFPSShown ) then drawFPS() end
	
	
	-- FPS固定法：https://love2d.org/wiki/love.timer.sleep
	local cur_time = love.timer.getTime()
	if next_time <= cur_time then
	  next_time = cur_time
	  return
	end
	love.timer.sleep(next_time - cur_time)	
		
end


--=========================================================
-- ENERGYゲージ表示
--=========================================================
function drawEnergyGauge ( x, y )
	
	local r,g,b,a = love.graphics.getColor()
	local currentLineWidth = love.graphics.getLineWidth()
	
	local energyColor      = {0,1,0,1}
	local energyColor_prev = {1,0,0,1}
	local energyTextColor  = {1,1,1,1}

	if ( energy < 10 ) then 
		energyColor = { 1,0,0,1 }  
		energyTextColor = { 1,0,0,1 }  
	end
	
	local energyGaugeMax = 195
	local energyGaugeCurrent = math.floor ( energyGaugeMax * energy / energyMax )
	local energyGaugePrev    = math.floor ( energyGaugeMax * energyPrev / energyMax )
	
	love.graphics.setColor (0,0,0,1)
	love.graphics.rectangle ( "fill", x, y,  energyGaugeMax, 30, 5 )

	love.graphics.setColor ( energyColor_prev )
	love.graphics.rectangle ( "fill", x, y,  energyGaugePrev, 30, 0 )

	love.graphics.setColor ( energyColor )
	love.graphics.rectangle ( "fill", x, y,  energyGaugeCurrent, 30, 0 )

	love.graphics.setColor ( 1,1,1,1)
	love.graphics.setLineWidth (2)
	love.graphics.rectangle ( "line", x, y,  energyGaugeMax, 30, 5 )

	love.graphics.setLineWidth(currentLineWidth)

	love.graphics.setColor ( energyTextColor )
	
	local font = fonts.score
	local text = "ENERGY："..string.format ( "%03d", energy ).."/"..energyMax
	printWithOutline ( text, math.floor(x + energyGaugeMax/2 - font:getWidth(text)/2), y+5, font )


	love.graphics.setColor(r,g,b,a)
end

--=========================================================
-- おにぎり残り数表示
--=========================================================
function drawGoodWillLeft ( x, y )
	
	love.graphics.draw ( spriteSheet, spriteQuad_goodwill, x, y )
	
	local cf = love.graphics.getFont()

	love.graphics.setFont(fonts.goodWillLeft)
	
	local text = " x" .. tostring(goodWillLeft)
	
	if ( mode == "story") then
		text = text .. "/" .. tostring(goodWillLeftInit)
	end
	
	love.graphics.print ( text, x + 30, y + 0 )
	
	love.graphics.setFont(cf)
	
end


--=========================================================
-- 実績達成メッセージ表示
--=========================================================
function drawFeatAchievedMessage ()

	-- 実績達成メッセージ
	for i = 1, #featAchievedMessages, 1 do
		featAchievedMessages[i]:draw(i)
	end
	
end

--=========================================================
-- FPS表示
--=========================================================
local isFPSShown = false
function drawFPS()

	local currentFont = love.graphics.getFont()
	
	local fps = string.format("%02d", love.timer.getFPS() )
	local font = fonts.default
	
	local fpsMessage = "FPS : "..fps
	
	
	love.graphics.setFont(font)

	love.graphics.setColor(0,0,0,1)
	love.graphics.print ( fpsMessage, WIDTH - font:getWidth(fpsMessage)-5 + 2, 5 + 2, 0, 1,1,0,0)
	love.graphics.setColor(1,1,0,1)
	love.graphics.print ( fpsMessage, WIDTH - font:getWidth(fpsMessage)-5, 5, 0, 1,1,0,0)
	love.graphics.setColor(1,1,1,1)
	
	love.graphics.setFont(currentFont)

end

--=========================================================
-- セーブデータ書き込み
--=========================================================
toSave = function () 

	-- セーブデータ書き込み
	local saveData = {}
	for i = 1, 1100, 1 do
		
		local data = math.random ( 0,9999 )
		
		saveData [ #saveData + 1 ] = data
		
	end
	
	local trueFlag = 32

	saveData [  10 ] = ternary ( getFeatMonitor ("turorialComplete"      ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [  50 ] = ternary ( getFeatMonitor ("firstStageClear"       ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 100 ] = ternary ( getFeatMonitor ("allClear"              ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 150 ] = ternary ( getFeatMonitor ("allClear_noMiss"       ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 250 ] = ternary ( getFeatMonitor ("afar1"                 ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 300 ] = ternary ( getFeatMonitor ("afar2"                 ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 350 ] = ternary ( getFeatMonitor ("afar3"                 ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 400 ] = ternary ( getFeatMonitor ("allAreaClear"          ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 450 ] = ternary ( getFeatMonitor ("allAreaClear_noMiss"   ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 500 ] = ternary ( getFeatMonitor ("consecution1"          ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 550 ] = ternary ( getFeatMonitor ("consecution2"          ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 600 ] = ternary ( getFeatMonitor ("consecution3"          ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 650 ] = ternary ( getFeatMonitor ("charge1"               ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 700 ] = ternary ( getFeatMonitor ("charge2"               ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 750 ] = ternary ( getFeatMonitor ("charge3"               ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 800 ] = ternary ( getFeatMonitor ("left1"                 ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 850 ] = ternary ( getFeatMonitor ("left2"                 ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 900 ] = ternary ( getFeatMonitor ("noOnigiri"             ).isAchieved, trueFlag, math.random(100, 999) )
	saveData [ 950 ] = ternary ( getFeatMonitor ("exploreTheGreatUnknown").isAchieved, trueFlag, math.random(100, 999) )
	saveData [1000 ] = ternary ( getFeatMonitor ("recoverFromNearDeath"  ).isAchieved, trueFlag, math.random(100, 999) )
	local saveDataSerial = ""
	
	for i = 1, #saveData, 1 do
		
		saveDataSerial = saveDataSerial..saveData[i]
		
		if ( i < #saveData ) then
			saveDataSerial = saveDataSerial.."zun"
		end
		
	end
	
	utils.writeFile ( "save.zun", saveDataSerial )
	
	--local data = utils.readFile ( "save.zun" )
	--print(data)
	
end


--=========================================================
-- セーブデータ読み込み
--=========================================================
toLoad = function () 
	
	local saveDataSerial = utils.readFile ( "save.zun" )
	
	local saveData = utils.split ( saveDataSerial, "zun")
	
	local trueFlag = "32"
	
	local trueCount = 0
	for i = 1, #saveData, 1 do
		if (saveData[i] == trueFlag) then trueCount = trueCount + 1 end
	end
	
	if ( #saveData == 1100 and trueCount <= 20 ) then -- trueCount の件数が全実績数より多ければエラー
	
		-- 実績
		getFeatMonitor ( "turorialComplete"      ).isAchieved = (saveData [  10 ] == trueFlag)
		getFeatMonitor ( "firstStageClear"       ).isAchieved = (saveData [  50 ] == trueFlag)
		getFeatMonitor ( "allClear"              ).isAchieved = (saveData [ 100 ] == trueFlag)
		getFeatMonitor ( "allClear_noMiss"       ).isAchieved = (saveData [ 150 ] == trueFlag)
		getFeatMonitor ( "afar1"                 ).isAchieved = (saveData [ 250 ] == trueFlag)
		getFeatMonitor ( "afar2"                 ).isAchieved = (saveData [ 300 ] == trueFlag)
		getFeatMonitor ( "afar3"                 ).isAchieved = (saveData [ 350 ] == trueFlag)
		getFeatMonitor ( "allAreaClear"          ).isAchieved = (saveData [ 400 ] == trueFlag)
		getFeatMonitor ( "allAreaClear_noMiss"   ).isAchieved = (saveData [ 450 ] == trueFlag)
		getFeatMonitor ( "consecution1"          ).isAchieved = (saveData [ 500 ] == trueFlag)
		getFeatMonitor ( "consecution2"          ).isAchieved = (saveData [ 550 ] == trueFlag)
		getFeatMonitor ( "consecution3"          ).isAchieved = (saveData [ 600 ] == trueFlag)
		getFeatMonitor ( "charge1"               ).isAchieved = (saveData [ 650 ] == trueFlag)
		getFeatMonitor ( "charge2"               ).isAchieved = (saveData [ 700 ] == trueFlag)
		getFeatMonitor ( "charge3"               ).isAchieved = (saveData [ 750 ] == trueFlag)
		getFeatMonitor ( "left1"                 ).isAchieved = (saveData [ 800 ] == trueFlag)
		getFeatMonitor ( "left2"                 ).isAchieved = (saveData [ 850 ] == trueFlag)
		getFeatMonitor ( "noOnigiri"             ).isAchieved = (saveData [ 900 ] == trueFlag)
		getFeatMonitor ( "exploreTheGreatUnknown").isAchieved = (saveData [ 950 ] == trueFlag)
		getFeatMonitor ( "recoverFromNearDeath"  ).isAchieved = (saveData [1000 ] == trueFlag)
	else
		
		if ( saveDataSerial == "zun" ) then
			print ("工場出荷状態："..saveDataSerial)
		else
			print ("セーブデータが存在しないか壊れています。"..#saveData.. "/" ..trueCount)
		end
	end
	

end





