

NarrationBox = {}
NarrationBox.new = function ( params )
	
	local this = {}
	this.className = "NarrationBox"
	this.params = paramas
	
	this.chars = {}
	this.lines = {}
	this.lineWidth = 360
	this.currentIndex = 0
	
	this.wait = 0
	this.waitMax = 10
	
	this.x = 0
	this.y = 0
	this.w = 400
	this.h = 100
	this.charOffsetX = 20
	this.charOffsetY = 20
	
	this.font = fonts.default
	
	this.isActive = false
	
	--=========================================================
	-- 更新
	--=========================================================
	this.init = function (self)
		self.chars = {}
		self.lines = {}
		self.currentIndex = 0
		self.wait = 0
		self.isActive = false
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( mode == "tutorial" ) then
			tutorial_Narration ( self )
		end
		
		if ( not self.isActive ) then
			return
		end
		
		if ( self.wait >= self.waitMax ) then
			
			self.currentIndex = self.currentIndex + 1
			if ( self.currentIndex > #self.chars ) then
				self.currentIndex = #self.chars
			else
				-- プププ音
				playSound ( sounds["charPut"] )
			end
			
		else
			self.wait = self.wait + 1
		end
		
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)

		if ( not self.isActive ) then
			return
		end
	
		local r,g,b,a = love.graphics.getColor()
		local currentLineWidth = love.graphics.getLineWidth()
		local currentFont = love.graphics.getFont()
		
		love.graphics.setLineWidth ( 2 )
		
		love.graphics.setColor ( 0,0,0, 0.1 )
		love.graphics.rectangle ( "fill", self.x, self.y, self.w, self.h, 10 )
		love.graphics.setColor ( 1,1,1,1 )
		love.graphics.rectangle ( "line", self.x, self.y, self.w, self.h, 10 )
		
		local font = self.font
		love.graphics.setFont ( font )
		
		local currentCharNum = 0
		for n = 1, #self.lines, 1 do

			if ( currentCharNum > self.currentIndex ) then break end
			
			local line = self.lines[n]
			
			local text = ""
			for i = 1, #line, 1 do
				
				if ( currentCharNum > self.currentIndex ) then break end
				
				text = text .. line[i]
				currentCharNum = currentCharNum + 1
			end
			love.graphics.print ( text, self.x + self.charOffsetX, self.y + self.charOffsetY + (font:getHeight()*2.0 * (n-1)) )
			
		end
		

		love.graphics.setFont(currentFont)
		love.graphics.setLineWidth(currentLineWidth)
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

