--=========================================================
--
-- 自機
--
--=========================================================

PlayerMachine = {}
PlayerMachine.new = function ( params )
	
	local this = {}
	this.className = "PlayerMachine"
	this.params = paramas
	
	this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.spriteQuad_crash = {}
	this.spriteQuad_crash[#this.spriteQuad_crash + 1] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_crash[#this.spriteQuad_crash + 1] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )


	this.x = canvas_field:getWidth() / 2
	this.y = HEIGHT 
	this.speed = 6
	
	this.isCrashing = false
	this.crashAnimeCount = 0
	this.crashAnimeWait = 0
	this.crashAnimeWaitMax = 5
	
	this.isGaining = false
	this.gainingAnimeWait = 0
	
	this.isLosing = false
	this.losingAnimeWait = 0
	
	this.isButtonPressing = false
	
	this.hitSize = 10
--	this.hitSize = 15
	this.hitOffsetX = 0
	this.hitOffsetY = 2

	this.blownoffCount = 0
	this.blownoffCountMax = 60
	this.blownoffX = 0
	this.blownoffY = 0

	this.blinkCount = 0
--	this.blinkCountMax = 60
	this.blinkCountMax = 90
	
	this.angle = 0
	this.alpha = 1
	
	this.energyAlertLimit = 10
	this.energyAlertCount = 0
	
	this.emptyCount = 0
	this.emptyCountMax = 90
	
	this.moveDegree_byTutorial = nil
	
	
	
	--=========================================================
	-- 初期状態にする
	--=========================================================
	this.init = function (self)
		
		self.x = canvas_field:getWidth() / 2
		self.y = canvas_field:getHeight() * 0.7
		self.angle = 0
		self.blownoffCount = 0
		self.alpha = 1
		self.emptyCount = 0
		self.moveDegree_byTutorial = nil
		self.isCrashing = false

	end
	
	--=========================================================
	-- クラッシュ
	--=========================================================
	this.crash = function (self) 
		
		playSound ( sounds["crash"] )
		
		self.isCrashing = true
		self.crashAnimeCount = 1
		self.crashAnimeWait = self.crashAnimeWaitMax
		self.blinkCount = 0
	end

	--=========================================================
	-- 吹き飛び
	--=========================================================
	this.blownoff = function (self, hitObj) 
		
		playSound ( sounds["damage"] )
		self.blownoffCount = self.blownoffCountMax
		
		-- 当たった対象との位置関係で吹き飛ぶ方向を決める
		if ( hitObj ) then
			
			local radian = math.atan2 ( self.y - hitObj.y,  self.x - hitObj.x)
			local radius = 1
			self.blownoffX = math.cos ( radian ) * radius
			self.blownoffY = math.sin ( radian ) * radius
		
		-- 対象未指定の場合はランダム
		else
			self.blownoffX = ({-1, 1})[math.random (1,2)]
			self.blownoffY = 1 -- Y方向は下向きで決め打ち
		end
		
	end
	
	--=========================================================
	-- 無敵
	--=========================================================
	this.blink = function (self) 
		self.blinkCount = self.blinkCountMax
	end
	
	--=========================================================
	-- アイテム取得
	--=========================================================
	this.getItem = function (self, item) 
		
		item.isEnd = true
		
		if ( item.id == "onigiriA" ) then
		
			goodWillLeft = goodWillLeft + 5
			if ( energy > energyMax ) then energy = energyMax end
			
			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "Onigiri +5", self.x, self.y )
		
		elseif ( item.id == "onigiriB" ) then
		
			goodWillLeft = goodWillLeft + 10
			if ( energy > energyMax ) then energy = energyMax end

			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "Onigiri +10", self.x, self.y )
			
		elseif ( item.id == "onigiriC" ) then
		
			goodWillLeft = goodWillLeft + 15
			if ( energy > energyMax ) then energy = energyMax end

			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "Onigiri +15", self.x, self.y )
			

		elseif ( item.id == "onigiriD" ) then
		
			goodWillLeft = goodWillLeft + 20
			if ( energy > energyMax ) then energy = energyMax end

			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "Onigiri +20", self.x, self.y )
			
		elseif ( item.id == "limitUp" ) then
			
			energyMax = energyMax + 10
			
			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "Limit 10up", self.x, self.y )
			
		elseif ( item.id == "extend" ) then
		
			--left = left + 1
			left_add()

			self.isGaining = true
			self.gainingAnimeWait = 60
			playSound ( sounds["gain"] )
			addEffectMessage ( "1up", self.x, self.y )
			
		end
		
	end
		
	--=========================================================
	-- 反応を受け取る：肯定的
	--=========================================================
	this.gain = function (self, rate) 
		
		if ( rate == nil ) then rate = 1 end
		
		local value = 5*rate

--		energy = energy + value

		self.isGaining = true
		self.gainingAnimeWait = 60
		energy = energy + value
		if ( energy > energyMax ) then 
			
			left_addEnergy ( energy - energyMax )
			
			energy = energyMax 
			
		end
		
		playSound ( sounds["gain"] )
		addEffectMessage ( "Energy +"..value, self.x, self.y )
	end
	
	--=========================================================
	-- 反応を受け取る：否定的
	--=========================================================
	this.lose = function (self, rate) 
		
		if ( rate == nil ) then rate = 1 end
		
		local value = 5*rate

--		energy = energy - value

		self.isLosing = true
		self.losingAnimeWait = 60
		energy = energy - value
		if ( energy < 0 ) then energy = 0 end
		
		playSound ( sounds["lose"] )
		addEffectMessage ( "Energy -"..value, self.x, self.y )
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		-- Gain中
		if ( self.isGaining ) then
			self.gainingAnimeWait = self.gainingAnimeWait - 1
			if ( self.gainingAnimeWait <= 0 ) then
				self.isGaining = false
			end
		end
		
		-- Lose中
		if ( self.isLosing ) then
			self.losingAnimeWait = self.losingAnimeWait - 1
			if ( self.losingAnimeWait <= 0 ) then
				self.isLosing = false
			end
		end		
		
		-- 吹き飛ばされ中
		if ( self.blownoffCount > 0 ) then
			self.blownoffCount = self.blownoffCount - 1
			
			self.x = self.x + self.blownoffX
			self.y = self.y + self.blownoffY
			self.angle = (self.angle + ( math.abs(self.blownoffX)/self.blownoffX )  /3)%360 --math.floor(self.blownoffCount / 5)%72
			
			if ( self.blownoffCount <= 0 ) then
				self:blink()
			end
		else
			self.angle = 0
		end
		
		-- 無敵中
		if ( self.blinkCount > 0 ) then
			self.blinkCount = self.blinkCount - 1
			self.alpha = math.floor(self.blinkCount / 2)%2
		else
			self.alpha = 1
		end

		-- エネルギー切れ中
		if ( energy <= 0 and not self.isCrashing  ) then
			
			if ( not sounds["emptyGas"]:isPlaying() ) then
				playSound ( sounds["emptyGas"] )
			end
			
			self.emptyCount = self.emptyCount + 1
			if ( self.emptyCount >= self.emptyCountMax ) then
				self:crash()
			end
			
			self.angle = self.angle + math.random ( -1, 1 )  --math.floor(self.emptyCount / 3)%120
			
			self.x = self.x + math.random ( -1, 1 )
			self.y = self.y + math.random ( -1, 1 )
			
		-- エネルギー残量わずか中
		elseif ( energy < self.energyAlertLimit and not self.isCrashing ) then
			
			if ( not sounds["alert"]:isPlaying() ) then
				playSound ( sounds["alert"] )
			end
			
			self.energyAlertCount = self.energyAlertCount + 1
		else
			self.energyAlertCount = 0
			self.emptyCount = 0
		end
--[[
		if ( energy <= 0 and not self.isCrashing  ) then
			self:crash()
		end
		if ( energy < 0 ) then
			energy = 0
		end
]]--		
		-- クラッシュ中
		if ( self.isCrashing ) then
			--[[
				self.isCrashing = false
				self.crashAnimeCount = 0
				self.crashAnimeWait = 0
				self.crashAnimeWaitMax = 2			
			]]--
			
			if ( self.crashAnimeWait <= 0 ) then
				
				self.crashAnimeWait = self.crashAnimeWaitMax
				
				self.crashAnimeCount = self.crashAnimeCount + 1
				if ( self.crashAnimeCount > #self.spriteQuad_crash ) then
					self.crashAnimeCount = 1
				end
				
			else
				self.crashAnimeWait = self.crashAnimeWait - 1
			end
			
		end
		
		if ( mode == "tutorial" ) then
			
			tutorial_PlayerMachine ( self )
			
		-- 無事なとき（制御可能なとき）
		elseif ( not self.isCrashing and self.blownoffCount <= 0 and energy > 0) then
		
			-- 移動
			local degree = nil

			local stickDeg = getStickDeg()
			if ( stickDeg ) then
				degree = stickDeg
			end			
						
			if ( love.keyboard.isDown ( "left"  ) or gamePad["left"] ) then 
				if ( love.keyboard.isDown ( "up"  ) or gamePad["up"] ) then 
					degree = 225
				elseif ( love.keyboard.isDown ( "down"  ) or gamePad["down"] ) then 
					degree = 135
				else
					degree = 180
				end
			
			elseif ( love.keyboard.isDown ( "right"  ) or gamePad["right"] ) then 
				if ( love.keyboard.isDown ( "up"  ) or gamePad["up"] ) then 
					degree = 315
				elseif ( love.keyboard.isDown ( "down"  ) or gamePad["down"] ) then 
					degree = 45
				else
					degree = 0
				end
				
			elseif ( love.keyboard.isDown ( "up"  ) or gamePad["up"] ) then 
					degree = 270
				
			elseif ( love.keyboard.isDown ( "down"  ) or gamePad["down"] ) then 
					degree = 90
			end
			
			if ( degree ) then
				self.x = self.x + math.cos ( math.rad(degree) ) * self.speed
				self.y = self.y + math.sin ( math.rad(degree) ) * self.speed
			end
			
			-- 射出
			if ( nonRepeatButton_z ) then
				popGoodWill()
			end
			
		end
		
		-- 範囲内に収める
		local fieldWidth  = canvas_field:getWidth()
		local fieldHeight = canvas_field:getHeight()
		
		if ( self.x < 0 ) then self.x = 0 
		elseif ( self.x > fieldWidth ) then self.x = fieldWidth end
		
		if ( self.y < 0 ) then self.y = 0 
		elseif ( self.y > fieldHeight ) then self.y = fieldHeight end
				
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
		
		local r,g,b,a = love.graphics.getColor()
		

		local color = colors["White"]
		
		if ( self.isGaining ) then
			if ( self.gainingAnimeWait%5 <= 2 ) then
				color = colors["A"]
			end
		end
		if ( self.isLosing ) then
			if ( self.losingAnimeWait%5 <= 2 ) then
				color = colors["B"]
			end
		end
		
		-- エネルギーが切れたときもここに入ってくる
		if ( energy < self.energyAlertLimit ) then
			
			if ( self.energyAlertCount%10 <= 5 ) then
				color = colors["B"]
			end
		end
		
		love.graphics.setColor ( color.r, color.g, color.b, self.alpha )
		
				
		--local offsetX = SPRITE_WIDTH/2
		--local offsetY = SPRITE_HEIGHT/2
		local offsetX = 32/2
		local offsetY = 32/2
		
		local angle = self.angle
		
		if ( self.isCrashing ) then
			love.graphics.draw ( spriteSheet, self.spriteQuad_crash [ self.crashAnimeCount ], self.x, self.y, angle, 1.0,1.0, offsetX, offsetY )
		else
			love.graphics.draw ( spriteSheet, self.spriteQuad, self.x, self.y, angle, 1.0,1.0, offsetX, offsetY )
		end
		
		
		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		
		love.graphics.setColor ( r,g,b,a )

	end
	
	return this
end
 

