--=========================================================
--
-- 返答
--
--=========================================================

Reaction = {}
Reaction.new = function ( params )
	
	local this = {}
	this.className = "Reaction"
	this.params = paramas
	
	this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.spriteQuad_banish = {}
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 3 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 4 * SPRITE_WIDTH, 3 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.x = 0
	this.y = 0
	this.speed = 5
	
	this.moveDirection = 0 -- ラジアンで
	
	this.hitSize = {
		A = {
			hitSize = 8,
			hitSize_forRock = 12
		},
		B = {
			hitSize = 1,
			hitSize_forRock = 15
		}
	}

	this.hitOffsetX = 0
	this.hitOffsetY = 0
	
	this.type = "A"
	
	this.isEnd = false
	
	this.isBanishing = false
	this.banishAnimeCount = 0
	this.banishAnimeWait = 0
	this.banishAnimeWaitMax = 2
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		if ( not self.isBanishing ) then
		
			self.x = self.x + math.cos ( self.moveDirection ) * self.speed
			self.y = self.y + math.sin ( self.moveDirection ) * self.speed
			
			if ( self.x < -1 * SPRITE_WIDTH or self.x > canvas_field:getWidth() + SPRITE_WIDTH or self.y < -1 * SPRITE_HEIGHT or self.y > canvas_field:getHeight() + SPRITE_HEIGHT ) then
				self.isEnd = true
			end

			-- 自機との当たり判定
			if ( not playerMachine.isCrashing ) then -- 連続で当たるのも悪くないかも
				local distToPlayer = utils.getDistance ( 
					self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
					playerMachine.x + playerMachine.hitOffsetX, playerMachine.y + playerMachine.hitOffsetY ) 
					
				if ( distToPlayer < ( playerMachine.hitSize + self.hitSize[self.type].hitSize ) ) then
					
					if ( self.type == "A" ) then
						playerMachine:gain()
					elseif ( self.type == "B" ) then
						playerMachine:lose()
					end
					
					self.isEnd = true
				end
			end

			-- 岩との当たり判定：Lose型のもののみ、岩で消えることとする
			if ( self.type == "B" ) then
				for i = 1, #rocks, 1 do
				
					local distToRock = utils.getDistance ( 
						self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
						rocks[i].x + rocks[i].hitOffsetX, rocks[i].y + rocks[i].hitOffsetY ) 
					
					if ( distToRock < ( rocks[i].hitSize + self.hitSize[self.type].hitSize_forRock ) ) then
						self.isBanishing = true
						self.banishAnimeCount = 1
						self.banishAnimeWait = self.banishAnimeWaitMax
					end
					
				end
			end


		-- 消滅中
		else
		
			if ( self.banishAnimeWait <= 0 ) then
				self.banishAnimeCount = self.banishAnimeCount + 1
				self.banishAnimeWait = self.banishAnimeWaitMax
				
				if ( self.banishAnimeCount > #self.spriteQuad_banish ) then
					self.isEnd = true
				end
			else
				self.banishAnimeWait = self.banishAnimeWait - 1
			end
			
			
		end
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		if ( self.isEnd ) then
			return
		end
		
		local r,g,b,a = love.graphics.getColor()
		
		local color = colors[ self.type ]
		love.graphics.setColor ( color.r, color.g, color.b, color.a )
		
		local drawX = self.x - SPRITE_WIDTH/2
		local drawY = self.y - SPRITE_HEIGHT/2
		
		
		if ( self.isBanishing ) then
			love.graphics.draw ( spriteSheet, self.spriteQuad_banish[self.banishAnimeCount], drawX, drawY )
		else
			love.graphics.draw ( spriteSheet, self.spriteQuad, drawX, drawY )
		end
				
		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize[self.type].hitSize )
			
			love.graphics.setColor ( 1,0,0,0.5 )
			--love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize[self.type].hitSize_forRock )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

