--=========================================================
--
-- 未知・大型
--
--=========================================================
Unknown_big = {}
Unknown_big.new = function ( params )
	
	local this = {}
	this.className = "Unknown_big"
	this.params = paramas
	
	this.spriteQuads = {}
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 6 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH*2, SPRITE_HEIGHT*2, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 6 * SPRITE_WIDTH, 2 * SPRITE_HEIGHT, SPRITE_WIDTH*2, SPRITE_HEIGHT*2, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 6 * SPRITE_WIDTH, 0 * SPRITE_HEIGHT, SPRITE_WIDTH*2, SPRITE_HEIGHT*2, spriteSheet:getDimensions() )
	this.spriteQuads [#this.spriteQuads + 1] = love.graphics.newQuad ( 6 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH*2, SPRITE_HEIGHT*2, spriteSheet:getDimensions() )
	
	this.animationWaitMax = 3
	this.animationWait    = this.animationWaitMax
	this.animationCount   = 1
	
	this.x = 0
	this.y = 0
	this.speed = 5
	
	this.hitSize = 30
	this.hitOffsetX = 0
	this.hitOffsetY = 0
	
	this.type = "A"
	
	this.isLeaving = false
	this.leavingAnimationCount = 0
	this.isEnd = false
	
	this.recieveCount = 0
	this.remainCenterCount = nil
	this.isRemainCenterEnd = false
	
	this.laserDegree = nil
	this.laserWidth = 3
	this.laserLong = 1000
	this.laserX = 0
	this.laserY = 0
		
	--=========================================================
	-- 初期設定
	--=========================================================
	this.init = function (self)
		
		--local left_right = math.random(100)
		--local type       = math.random(100)
		local left_right = crand_forLR:get()
		local type       = crand_forAB:get()
		local y          = math.random(10, canvas_field:getHeight()/3)
		
		--if ( type < 50 ) then
		--if ( type_lot[type_currentLotIndex] == 0 ) then
		if ( type == 1 ) then
			self.type = "A"
		else
			self.type = "B"
		end
		
		--type_currentLotIndex = type_currentLotIndex + 1
		--if ( type_currentLotIndex > #type_lot ) then type_currentLotIndex = 1 end
		
		--if ( left_right < 50 ) then
		if ( left_right == 1 ) then
			
			self.x = -1 * SPRITE_WIDTH
			self.y = y
			self.speed = 2
			
		else
			
			self.x = canvas_field:getWidth() + SPRITE_WIDTH
			self.y = y
			self.speed = -2
		end
		--print(self.x, self.y, self.type, self.speed)
	end
	
	--=========================================================
	-- おにぎりを受け取って、「お礼」を出す
	--=========================================================
	this.recieveGoodWill = function (self)
		
		playSound ( sounds["reaction"] )
		
		local reactNum = 20 -- 固定
		
		for i = 1, reactNum, 1 do
		
			--local angle = crand_forResAngle:get()
			local angle = 20 + (140/reactNum) * (i-1) -- 角度は規則正しくしておく
			
			local types = {"A", "B"}
			addReaction ( self.x, self.y, math.rad ( angle ), types[i%2 + 1] )
		end
		
		self.recieveCount = self.recieveCount + 1
		
		-- 3回届けると 1up出現
		if ( self.recieveCount == 3 ) then
			addItem("extend", self.x, self.y)
		end

		local fm = getFeatMonitor ( "exploreTheGreatUnknown" )
		if ( fm ) then
			fm:notify_received(self)
		end
		
		-- deliver回数の計上はしない
		--[[
		-- 50回以降、25回ごとに1up出現
		numOfDeliveries = numOfDeliveries + 1
		if ( numOfDeliveries >= 50 ) then
			if ( numOfDeliveries%25 == 0 ) then
				addItem("extend")
			end
		end
		]]--
		
		-- 去らない
		--self.isLeaving = true
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		-- 退去中
		if ( self.isLeaving ) then
			
			local leaveDirection = -1
			if ( self.x > canvas_field:getWidth()/2 ) then
				leaveDirection = 1
			end
			
			self.x = self.x + math.abs(self.speed) * 1.5 * leaveDirection
			self.leavingAnimationCount = self.leavingAnimationCount + 1
			
			if ( self.x < -1 * SPRITE_WIDTH or self.x > canvas_field:getWidth() + SPRITE_WIDTH ) then
				self.isEnd = true
			end
			
		else
			
			if ( self.animationWait <= 0 ) then
				self.animationWait = self.animationWaitMax
				
				self.animationCount = self.animationCount + 1
				if ( self.animationCount > #self.spriteQuads ) then
					self.animationCount = 1
				end
			
			else
				self.animationWait = self.animationWait - 1
			end
			
			-- 真ん中で一時停止中
			if ( self.remainCenterCount ) then
				
				self.remainCenterCount = self.remainCenterCount - 1
				self.laserDegree = self.laserDegree + 6
				if ( self.remainCenterCount < 0 ) then
					self.remainCenterCount = nil
					self.isRemainCenterEnd = true
					self.laserDegree = nil
					
				else
					self:setupLaserPos()
				end
				
			else
				-- 真ん中で一時停止する判定
				if ( not self.isRemainCenterEnd and utils.isInBetween (canvas_field:getWidth()/2, self.x, self.x + self.speed) ) then
					self.x = canvas_field:getWidth()/2
					self.remainCenterCount = 120
					self.laserDegree = 270
					self:setupLaserPos()
					playSound ( sounds["laser"] )
				else
					-- 通常移動
					self.x = self.x + self.speed
					if ( self.x < -1 * SPRITE_WIDTH*2 or self.x > canvas_field:getWidth() + SPRITE_WIDTH*2 ) then
						self.isEnd = true
					end
				end
			end
			
			
			
			-- 自機との当たり判定
			if ( not playerMachine.isCrashing and playerMachine.blownoffCount <= 0 and playerMachine.blinkCount <= 0 ) then -- 連続で当たるのも悪くないかも

				local distToPlayer = utils.getDistance ( 
					self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
					playerMachine.x + playerMachine.hitOffsetX, playerMachine.y + playerMachine.hitOffsetY ) 
				
				if ( distToPlayer < ( playerMachine.hitSize + self.hitSize ) ) then
					playerMachine:blownoff(self)
				end
			end
			
			-- 岩との当たり判定
			for i = 1, #rocks, 1 do
				
				local obj = rocks[i]

				if ( not obj.isEnd and not obj.isBanishing) then
					local distToObj = utils.getDistance ( 
						self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
						obj.x + obj.hitOffsetX, obj.y + obj.hitOffsetY ) 
					
					if ( distToObj < ( obj.hitSize + self.hitSize ) ) then
						--obj.isEnd = true
						obj:banish()
						playSound ( sounds["rockBanish"] )

					end
					
					-- レーザーの分
					if ( self.laserDegree ) then
						
						local hitSizeOffset = 20 -- 少し岩側にゲタを履かせる
						
						if ( utils.isCollideCircleAndLine ( 
								obj.x + obj.hitOffsetX, obj.y + obj.hitOffsetY, obj.hitSize + hitSizeOffset, 
								self.x, self.y, self.laserX, self.laserY, 
								self.laserWidth
						)) 
						then
							obj:banish()
							playSound ( sounds["rockBanish"] )
						end
					end
					
				end
				
			end
			
		end
		
	end
	
	--=========================================================
	-- レーザーの先端の座標を設定
	--=========================================================
	this.setupLaserPos = function ( self )

		self.laserX = self.x + math.cos(math.rad(self.laserDegree))*self.laserLong
		self.laserY = self.y + math.sin(math.rad(self.laserDegree))*self.laserLong
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		if ( self.isEnd ) then
			return
		end
		
		local r,g,b,a = love.graphics.getColor()
		local lineWidth = love.graphics.getLineWidth()
		
		local color = colors["Unknown"]
		
		if ( self.isLeaving ) then
			if ( self.leavingAnimationCount%5 <= 2 ) then
				color = colors [ self.type ]
			else
				color = colors [ "White" ]
			end
		end
		
		
		local drawX = self.x - SPRITE_WIDTH
		local drawY = self.y - SPRITE_HEIGHT
		
		-- レーザー
		if ( self.laserDegree ) then
			
			local currentLineWidth = love.graphics.getLineWidth()
			love.graphics.setLineWidth(self.laserWidth)
			
			local colors = { {1,0,0}, {0,1,0}, {0,0,1}, {1,1,0}, {1,1,1} }
			love.graphics.setColor ( colors [ self.remainCenterCount%#colors + 1 ]  )
			
			love.graphics.line ( self.x, self.y, self.laserX, self.laserY )

			love.graphics.setLineWidth(currentLineWidth)
		end

		love.graphics.setColor ( color.r, color.g, color.b, color.a )
		
		local quad = self.spriteQuads [ self.animationCount ]
		love.graphics.draw ( spriteSheet, quad, drawX, drawY )
		
		
		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

