local utils = {} 
utils.Move = function(from_x, from_y, to_x, to_y, distance) 
     
    result_x = from_x 
    result_y = from_y 
 
    d = math.sqrt( (to_x - from_x)^2 + (to_y - from_y)^2 ); 
 
    rate = 0 
    if ( d ~= 0 ) then  
        rate = (distance / d)  
    else  
        rate = 0  
    end 
 
    result_x = result_x + (to_x - from_x) * rate; 
    result_y = result_y + (to_y - from_y) * rate; 
     
 
    -- 超えた場合 
    if (from_x < to_x) then 
        if ( to_x < result_x) then 
            result_x = to_x; 
            result_y = to_y; 
        end 
    end 
    if (from_x > to_x) then 
        if ( to_x > result_x) then 
            result_x = to_x; 
            result_y = to_y; 
        end 
    end 
    if (from_y < to_y) then 
        if ( to_y < result_y) then 
            result_x = to_x; 
            result_y = to_y; 
        end 
    end 
    if (from_y > to_y) then 
        if ( to_y > result_y) then 
            result_x = to_x; 
            result_y = to_y; 
        end 
    end 
     
 
    return result_x, result_y; 
 
end 
 
 
utils.Approach = function( from, to, distance )  
 
    result = from; 
 
    if ( from > to ) then 
 
        result = result - distance; 
 
        if (result < to) then 
            result = to; 
        end 
     
    elseif ( result < to ) then 
 
        result = result + distance; 
 
        if (result > to) then 
            result = to; 
        end 
    end 
 
    return result; 
end 

utils.getDistance = function(from_x, from_y, to_x, to_y ) 
     
    d = math.sqrt( (to_x - from_x)^2 + (to_y - from_y)^2 ); 
	return d
end 

utils.isInBetween = function ( p, a, b ) 
	
	local result = false
	
	if  ((a-p)*(b-p) < 0) then
		result = true
	
	elseif ( p == a or p == b ) then
		result = true
	end
	
	return result
end


-- ベクトル外積
-- http://www.sousakuba.com/Programming/gs_dot_line_distance.html
utils.getCross_vector = function ( from_x, from_y, to_x, to_y) 
	return from_x * to_y - from_y * to_x
end

--点Pと線(AB)の距離
--http://www.sousakuba.com/Programming/gs_dot_line_distance.html
utils.getDistance_DotAndLine = function ( p_x, p_y,   a_x, a_y, b_x, b_y )

	--Vector2D AB,AP;
	--AB.x = B.x - A.x;
	--AB.y = B.y - A.y;
	--AP.x = P.x - A.x;
	--AP.y = P.y - A.y;
	
	local vAB_x = b_x - a_x
	local vAB_y = b_y - a_y
	local vAP_x = p_x - a_x
	local vAP_y = p_y - a_y

	--ベクトルAB、APの外積の絶対値が平行四辺形Dの面積になる
	local D = math.abs( utils.getCross_vector( vAB_x, vAB_y, vAP_x, vAP_y ) );
	
	-- AB間の距離
	local L = utils.getDistance ( a_x, a_y, b_x, b_y )

	local H = D / L
	
	return H
end


utils.isCollideCircleAndLine = function ( p_x, p_y, r, a_x, a_y, b_x, b_y, lineWidth )
	
	local result = false
	
	if (
		utils.isInBetween ( p_x, math.min(a_x, b_x) - r, math.max(a_x, b_x) + r )
		and
		utils.isInBetween ( p_y, math.min(a_y, b_y) - r, math.max(a_y, b_y) + r )
	) 
	then

		local d = utils.getDistance_DotAndLine ( p_x, p_y,  a_x, a_y, b_x, b_y )
		
		if ( d <= (r + lineWidth/2) ) then
			result = true
		end
	end
	
	return result
end


-- https://helloacm.com/split-a-string-in-lua/
utils.split = function (s, delimiter)
	result = {};
	for match in (s..delimiter):gmatch("(.-)"..delimiter) do
		table.insert(result, match);
	end
	return result;
end

utils.readFile = function ( fileName ) 
	
	local result = ""
	
	local fIN, message, errorCode = io.open( fileName, "r") 
	
	if ( message or errorCode) then
		print ("【utils.readFile】message : " .. message)
		print ("【utils.readFile】errorCode : " .. errorCode)
		return ""
	end
	
	local i = 1
	for line in fIN:lines() do
		
		if ( i > 1 ) then
			result = result .. "\n"
		end
		
		result = result .. line
		
		i = i + 1
	end
	
	fIN:close()
	
	return result
end

utils.writeFile = function ( fileName, text ) 
	
	local result = ""

	fOUT, message, errorCode = io.open(fileName, "w") 

	if ( message or errorCode) then
	
		print ("【utils.writeFile】message : " .. message)
		print ("【utils.writeFile】errorCode : " .. errorCode)
	
	else
		fOUT:write( text )
	end
	
	fOUT:close()
	
	return result
	
end
return utils 
